<?php
/* by Tomasz 'Devilshakerz' Mlynski [devilshakerz.com]; Copyright (C) 2014-2016
 released under Creative Commons BY-NC-SA 4.0 license: https://creativecommons.org/licenses/by-nc-sa/4.0/ */

namespace DVZMentions;

class DvzShoutboxAlerts
{
    static $oldMessage;

    static function dvzShoutboxShoutCommit($data)
    {
        $alertDetails = [
            'shout_id' => (int)$data['shout_id'],
        ];

        $locationData = [
            'shout_id' => (int)$data['shout_id'],
            'author'   => (int)$data['uid'],
        ];

        $calledUids = Parser::getCalledUids($data['text']);

        if ($calledUids) {
            Alerts::queueAlerts('dvzShoutbox', $alertDetails, $locationData, $calledUids, $data['uid']);
        }
    }

    static function dvzShoutboxUpdate($data)
    {
        self::$oldMessage = $data['text'];
    }

    static function dvzShoutboxUpdateCommit($data)
    {
        $alertDetails = [
            'shout_id' => (int)$data['shout_id'],
        ];

        $locationData = [
            'shout_id' => (int)$data['shout_id'],
            'author'   => (int)$data['uid'],
        ];

        $calledUidsOld = Parser::getCalledUids(self::$oldMessage);
        $calledUids = Parser::getCalledUids($data['text']);

        $calledUids = array_diff($calledUids, $calledUidsOld);

        if ($calledUids) {
            Alerts::queueAlerts('dvzShoutbox', $alertDetails, $locationData, $calledUids, $data['uid']);
        }
    }

    static function alertPossible($locationData, $uid)
    {
        return true;
    }

    static function myalertsLoadLang()
    {
        global $lang;
        $lang->load('dvz_mentions_alerts_dvzShoutbox');
    }
}
