<?php
/* by Tomasz 'Devilshakerz' Mlynski [devilshakerz.com]; Copyright (C) 2014-2016
 released under Creative Commons BY-NC-SA 4.0 license: https://creativecommons.org/licenses/by-nc-sa/4.0/ */

class MybbStuff_MyAlerts_Formatter_DVZMentionsPostFormatter extends MybbStuff_MyAlerts_Formatter_AbstractFormatter
{
    public function formatAlert(MybbStuff_MyAlerts_Entity_Alert $alert, array $outputAlert)
    {
        $alertDetails = $alert->getExtraDetails();

        require_once MYBB_ROOT.'inc/class_parser.php';
        $parser = new postParser;

        return $this->lang->sprintf(
            $this->lang->myalerts_dvz_mentions_post_alert,
            $outputAlert['from_user'],
            htmlspecialchars_uni($parser->parse_badwords($alertDetails['subject'])),
            $outputAlert['dateline']
        );
    }

    public function init()
    {
        $this->lang->load('dvz_mentions_alerts_post');
    }

    public function buildShowLink(MybbStuff_MyAlerts_Entity_Alert $alert)
    {
        $alertDetails = $alert->getExtraDetails();

        $postLink = $this->mybb->settings['bburl'] . '/' . get_post_link(
            (int)$alertDetails['pid'],
            (int)$alertDetails['tid']
        ) . '#pid' . (int)$alertDetails['pid'];

        return $postLink;
    }
}
