<?php
/**
 * MyBB 1.6
 * Copyright 2012 My-BB.Ir Group, All Rights Reserved
 *
 * Website: http://my-bb.ir
 *
 * $Id: mybbirlastthreadsprofile.php AliReza_Tofighi $
 */
 
// Disallow direct access to this file for security reasons
if(!defined("IN_MYBB"))
{
	die("Direct initialization of this file is not allowed.<br /><br />Please make sure IN_MYBB is defined.");
}

$plugins->add_hook("member_profile_end", "mybbirlastthreadsprofile");


function mybbirlastthreadsprofile_info()
{
	return array(
		"name"			=> "Last User's Threads in Profile",
		"description"	=> "",
		"website"		=> "http://my-bb.ir",
		"author"		=> "AliReza_Tofighi",
		"authorsite"	=> "http://my-bb.ir",
		"version"		=> "1.00",
		"guid" 			=> "d0ed7e9cd568bf8806067c016b480be4",
		"compatibility" => "*",
	);
}


function mybbirlastthreadsprofile_activate(){
	global $mybb, $db;
	include MYBB_ROOT."/inc/adminfunctions_templates.php";
	find_replace_templatesets("member_profile", "#".preg_quote('{$mybbirlastthreadsprofile}')."#i", '', 0);
	find_replace_templatesets("member_profile", "#".preg_quote('{$signature}')."#i", '{$mybbirlastthreadsprofile}{$signature}');	
}
function mybbirlastthreadsprofile_deactivate(){
	global $mybb, $db;
	include MYBB_ROOT."/inc/adminfunctions_templates.php";
	find_replace_templatesets("member_profile", "#".preg_quote('{$mybbirlastthreadsprofile}')."#i", '', 0);

}

function mybbirlastthreadsprofile()
{
	global $db, $mybb, $memprofile, $theme, $lang, $mybbirlastthreadsprofile;
	$threadlimit = 5;
	$query = $db->query("
		SELECT t.*, t.subject AS threadsubject, u.username, u.usergroup, u.displaygroup, i.*, i.name AS iconname,
		t.dateline AS threaddate, t.lastpost AS threadlastpost
		FROM ".TABLE_PREFIX."threads t
		LEFT JOIN ".TABLE_PREFIX."icons i ON (i.iid=t.icon)
		LEFT JOIN ".TABLE_PREFIX."users u ON (t.lastposter=u.username)
		WHERE t.visible = '1' And t.uid = '{$memprofile['uid']}'
		GROUP BY t.tid
		ORDER BY threadlastpost DESC
		LIMIT 0, {$threadlimit}
	");

	while($threads = $db->fetch_array($query))
	{

		if($threads['icon'] > 0)
		{
			$icon = "<img src=\"{$threads['path']}\" alt=\"{$threads['iconname']}\" title=\"{$threads['iconname']}\" />";
		}
		else
		{
			$icon = "&nbsp;";
		}

		if(strlen($threads['threadsubject']) > "40")
		{
			$threadsthreadsubject = htmlspecialchars(my_substr($threads['threadsubject'],0,40)."...");
		}
		else
		{
			$threadsthreadsubject = htmlspecialchars($threads['threadsubject']);
		}

		if(strlen($threads['forumname']) > "20")
		{
			$threadsforumname = my_substr($threads['forumname'],0,20)."...";
		}
		else
		{
			$threadsforumname = $threads['forumname'];
		}

		$threadlink = get_thread_link($threads['tid']);
		$forumlink = get_forum_link($threads['fid']);
		$replies = my_number_format($threads['replies']);
		$views = my_number_format($threads['views']);
		$lastpostdate = my_date($mybb->settings['dateformat'], $threads['threadlastpost']);
		$lastposttime = my_date($mybb->settings['timeformat'], $threads['threadlastpost']);
		$lastposter = format_name($threads['username'], $threads['usergroup'], $threads['displaygroup']);
		$lastposter = build_profile_link($lastposter, $threads['lastposteruid']);

		$last_thread .= "<tr>
			<td class=\"trow1\" align=\"center\" height=\"24\">$icon</td>
			<td class=\"trow2\"><a href=\"$threadlink\" title=\"$threads[threadsubject]\">$threadsthreadsubject</a></td>
			<td class=\"trow1\" align=\"center\">$replies</td>
			<td class=\"trow2\" align=\"center\">$views</td>
			<td class=\"trow1\"><span class=\"smalltext\">$lastpostdate $lastposttime<br />By: $lastposter</span></td>
	</tr>";

	}
	if(!$last_thread){
		$last_thread = "<tr><td class=\"trow1\" colspan=\"5\">There aren't any threads</td></tr>";
	}
	$mybbirlastthreadsprofile = "<br /><table border=\"0\" cellspacing=\"".$theme['borderwidth']."\" cellpadding=\"".$theme['tablespace']."\" class=\"tborder\">
			<tr>
				<td class=\"thead\" colspan=\"6\"><strong>Last Threads</strong></td>
			</tr>
				<tr>
					<td class=\"tcat\" width=\"5%\" height=\"24\">&nbsp;</td>
					<td class=\"tcat\" width=\"50%\"><span class=\"smalltext\"><strong>Subject</strong></span></td>
					<td class=\"tcat\" width=\"10%\" align=\"center\"><span class=\"smalltext\"><strong>Replies</strong></span></td>
					<td class=\"tcat\" width=\"10%\" align=\"center\"><span class=\"smalltext\"><strong>Views</strong></span></td>
					<td class=\"tcat\" width=\"25%\" align=\"center\"><span class=\"smalltext\"><strong>Last post</strong></span></td>
				</tr>
			<tbody>
			{$last_thread}
			</tbody>
		</table>";
}

?>
