<?php
    /**
     * Byte
     * Oct 23, 2015
     * Copyright 2015, All Rights Reserved
     * Website: generalbb.net
    */

    if(!defined("IN_MYBB")) die("Direct initialization of this file is not allowed.<br /><br />Please make sure IN_MYBB is defined.");

    $plugins->add_hook("newpoints_default_menu", "newpoints_rps_menu");
    $plugins->add_hook("newpoints_start", "newpoints_rps_page");

    function newpoints_rps_info()
    {
      return array(
         "name"       => 'Rock-Paper-Scissors',
         "description"  => 'Enables users to bet their points with one-another while playing RPS.',
         "website"     => 'http://generalbb.net',
         "author"      => 'Byte',
         "authorsite"   => 'http://generalbb.net',
         "version"     => '1.0',
         "compatibility" => '2',
         "guid"           => ''
      );
    }

    function newpoints_rps_install()
    {
      global $db;

      $db->write_query("CREATE TABLE `".TABLE_PREFIX."newpoints_rps_bets` (
        `betid` int(11) UNSIGNED NOT NULL auto_increment,
        `from` int(11) NOT NULL default '0',
        `to` int(11) NOT NULL default '0',
        `amount` int(11) NOT NULL default '0',
        `option` tinyint(1) NOT NULL default '0',
        `winner` int(11) NOT NULL default '0',
        `startdate` int(10) NOT NULL default '0',
        `enddate` int(10) NOT NULL default '0',
        PRIMARY KEY  (`betid`)
         ) ENGINE=MyISAM");

      newpoints_add_setting('newpoints_rps_ignoredgroups', 'newpoints_rps', 'Ignored Usergroups', 'Usergroups disallowed to use this feature? -1 for all, blank for none or comma seperate usergroups without spaces e.g. 4,5', 'text', '', 1);
      newpoints_add_setting('newpoints_rps_minbet', 'newpoints_rps', 'Minimum Bet Amount', 'The minimum amount a user can bet.', 'text', '50', 2);
      rebuild_settings();
    }

    function newpoints_rps_is_installed()
    {
      global $db;
      if($db->table_exists('newpoints_rps_bets')) return true;
    }

    function newpoints_rps_uninstall()
    {
      global $db;

      $db->drop_table('newpoints_rps_bets');
      newpoints_remove_settings("'newpoints_rps_ignoredgroups','newpoints_rps_minbet'");
      rebuild_settings();
    }

    function newpoints_rps_activate()
    {
        newpoints_add_template(
            'newpoints_rps',
            '<html>
                <head>
                    <title>{$lang->newpoints} - RPS</title>
                    {$headerinclude}
                </head>
                <body>
                    {$header}

                    <table width="100%" border="0" align="center">
                        <tr>
                            <td valign="top" width="180">
                                <table border="0" cellspacing="{$theme[\'borderwidth\']}" cellpadding="{$theme[\'tablespace\']}" class="tborder">
                                    <tr><td class="thead"><strong>Menu</strong></td></tr>
                                    {$options}
                                </table>
                            </td>

                            <td valign="top">
                                <form action="newpoints.php" method="POST">
                                    <input type="hidden" name="action" value="send_bet">
                                    <input type="hidden" name="postcode" value="{$mybb->post_code}">

                                    <table border="0" cellspacing="{$theme[\'borderwidth\']}" cellpadding="{$theme[\'tablespace\']}" class="tborder">
                                        <tr>
                                        <td class="thead" colspan="2"><strong>Rock-Paper-Scissors</strong></td>
                                        </tr>
                                        <tr>
                                        <td class="trow1" width="50%"><strong>User</strong><br><span class="smalltext">The user\'s name you want to send a bet.</span></td>
                                        <td class="trow1" width="50%"><input type="text" name="username" value="" class="textbox"></td>
                                        </tr>
                                        <tr>
                                        <td class="trow2" width="50%"><strong>Amount</strong><br><span class="smalltext">Enter the amount of points you want to bet.<br /><strong>Minimum bet: {$mybb->settings[\'newpoints_rps_minbet\']}</strong></span></td>
                                        <td class="trow2" width="50%"><input type="text" name="amount" value="" class="textbox"></td>
                                        </tr>
                                        <tr>
                                        <td class="trow1" width="50%"><strong>Option</strong><br><span class="smalltext">Rock, paper or scissors?</span></td>
                                        <td class="trow1" width="50%">
                                            <select name="option">
                                                <option value="1">Rock</option>
                                                <option value="2">Paper</option>
                                                <option value="3">Scissors</option>
                                            </select>
                                        </td>
                                        </tr>
                                        <tr>
                                        <td class="tfoot" width="100%" colspan="2" align="center"><input type="submit" name="submit" value="Submit"></td>
                                        </tr>
                                    </table>
                                </form><br />

                                <table width="100%" border="0" align="center">
                                    <td valign="top" width="70%">
                                        <table border="0" cellspacing="{$theme[\'borderwidth\']}" cellpadding="{$theme[\'tablespace\']}" class="tborder">
                                            <tr>
                                                <td class="thead" colspan="4"><strong>Recent Bets</strong></td>
                                            </tr>
                                            <tr>
                                                <td class="tcat" width="35%"><strong>From</strong></td>
                                                <td class="tcat" width="35%"><strong>To</strong></td>
                                                <td class="tcat" width="15%" align="center"><strong>Amount</strong></td>
                                                <td class="tcat" width="15%" align="center"><strong>Status</strong></td>
                                            </tr>

                                            {$recent_bets}

                                        </table>
                                    </td>

                                    <td valign="top" width="30%">
                                        <table border="0" cellspacing="{$theme[\'borderwidth\']}" cellpadding="{$theme[\'tablespace\']}" class="tborder">
                                            <tr>
                                            <td class="thead" colspan="2"><strong>Pending Bets</strong></td>
                                            </tr>
                                            <tr>
                                                <td class="tcat" width="80%"><strong>Username</strong></td>
                                                <td class="tcat" width="20%" align="center"><strong>Status</strong></td>
                                            </tr>

                                            {$pending_bets}

                                        </table>
                                    </td>
                                </table><br />

                                <table width="100%" border="0" align="center">
                                    <td valign="top">
                                        <table border="0" cellspacing="{$theme[\'borderwidth\']}" cellpadding="{$theme[\'tablespace\']}" class="tborder">
                                            <tr>
                                                <td class="thead" colspan="4"><strong>Betting Statistics</strong></td>
                                            </tr>
                                            <tr>
                                                <td class="trow1" width="25%"><strong>Games Played</strong></td>
                                                <td class="trow1" width="25%" align="center">{$games_played}</td>

                                                <td class="trow1" width="25%"><strong>Wins</strong></td>
                                                <td class="trow1" width="25%" align="center">{$wins}</td>
                                            </tr>

                                             <tr>
                                                <td class="trow1" width="25%"><strong>Total Profit</strong></td>
                                                <td class="trow1" width="25%" align="center">{$profit}</td>

                                                <td class="trow1" width="25%"><strong>Loses</strong></td>
                                                <td class="trow1" width="25%" align="center">{$loses}</td>
                                            </tr>

                                             <tr>
                                                <td class="trow1" width="25%"><strong>Total Wagered</strong></td>
                                                <td class="trow1" width="25%" align="center">{$total_wagered}</td>

                                                <td class="trow1" width="25%"><strong>Draws</strong></td>
                                                <td class="trow1" width="25%" align="center">{$draws}</td>
                                            </tr>
                                            </tr>
                                        </table>
                                    </td>
                                </table>
                            </td>
                        </tr>
                    </table>

                    {$footer}
                </body>
            </html>'
        );
    }

    function newpoints_rps_deactivate()
    {
        newpoints_remove_templates("'newpoints_rps'");
    }

    function newpoints_rps_menu(&$menu)
    {
      global $mybb;

      if ($mybb->input['action'] == 'rps')
         $menu[] = "&raquo; <a href=\"{$mybb->settings['bburl']}/newpoints.php?action=rps\">RPS</a>";
      else
         $menu[] = "<a href=\"{$mybb->settings['bburl']}/newpoints.php?action=rps\">RPS</a>";
    }

    function newpoints_rps_page()
    {
        global $mybb, $db, $lang, $theme, $header, $templates, $headerinclude, $footer, $options;

        if(!$mybb->user['uid']) return;
        if(is_member($mybb->settings['newpoints_rps_ignoredgroups'])) error_no_permission();

        if($mybb->input['action'] == 'rps')
        {
            // games played
            $total = $db->fetch_array($db->simple_select('newpoints_rps_bets', 'count(*) as games', "winner != 0 AND (`from` = {$mybb->user['uid']} OR `to` = {$mybb->user['uid']})"));
            $games_played = $total['games'];

            // wins
            $total = $db->fetch_array($db->simple_select('newpoints_rps_bets', 'count(*) as wins', "winner = {$mybb->user['uid']} AND (`from` = {$mybb->user['uid']} OR `to` = {$mybb->user['uid']})"));
            $wins = $total['wins'];

            // loses
            $total = $db->fetch_array($db->simple_select('newpoints_rps_bets', 'count(*) as loses', "winner != {$mybb->user['uid']} AND winner != -1 AND winner != 0 AND (`from` = {$mybb->user['uid']} OR `to` = {$mybb->user['uid']})"));
            $loses = $total['loses'];

            // draws
            $total = $db->fetch_array($db->simple_select('newpoints_rps_bets', 'count(*) as draws', "winner = -1 AND (`from` = {$mybb->user['uid']} OR `to` = {$mybb->user['uid']})"));
            $draws = $total['draws'];

            // profit
            $query = $db->simple_select('newpoints_rps_bets', 'amount, winner', "winner != -1 AND winner != 0 AND (`from` = {$mybb->user['uid']} OR `to` = {$mybb->user['uid']})");
            $profit = 0;
            while($game = $db->fetch_array($query))
            {
                if($game['winner'] == $mybb->user['uid'])
                    $profit += $game['amount'];
                else
                    $profit -= $game['amount'];
            }

            // wagered
            $query = $db->simple_select('newpoints_rps_bets', 'amount', "winner != 0 AND (`from` = {$mybb->user['uid']} OR `to` = {$mybb->user['uid']})");
            $total_wagered = 0;
            while($game = $db->fetch_array($query)) $total_wagered += $game['amount'];

            // pending bets
            $query = $db->simple_select('newpoints_rps_bets', '*', "`from` = {$mybb->user['uid']} AND winner = 0", array('limit' => 5));
            $pending_bets = '';
            while($pending_bet = $db->fetch_array($query))
            {
                $pending_bets .= "<tr>";
                $pending_bets .= "<td class=\"trow1\" width=\"70%\"><strong>". get_user($pending_bet['to'])['username'] ."</strong></td>";
                $pending_bets .= "<td class=\"trow1\" width=\"30%\" align=\"center\"><a href=\"newpoints.php?action=rejectbet&betid={$pending_bet['betid']}\">Cancel</a></td>";
                $pending_bets .= "</tr>";
            }

            // recent bets
            $query = $db->simple_select('newpoints_rps_bets', '*', "winner != 0 AND (`from` = {$mybb->user['uid']} OR `to` = {$mybb->user['uid']})", array('limit' => 5, 'order_by' => 'betid DESC'));
            $recent_bets = '';
            while($recent_bet = $db->fetch_array($query))
            {
                $recent_bets .= "<tr>";
                $recent_bets .= "<td class=\"trow1\" width=\"35%\"><strong><a href=\"member.php?action=profile&uid={$recent_bet['from']}\">". get_user($recent_bet['from'])['username'] ."</a></strong></td>";
                $recent_bets .= "<td class=\"trow1\" width=\"35%\"><strong><a href=\"member.php?action=profile&uid={$recent_bet['to']}\">". get_user($recent_bet['to'])['username'] ."</a></strong></td>";
                $recent_bets .= "<td class=\"trow1\" width=\"15%\" align=\"center\">{$recent_bet['amount']}</td>";
                $recent_bets .= "<td class=\"trow1\" width=\"15%\" align=\"center\">". work_out_status($recent_bet['winner']) ."</td>";
                $recent_bets .= "</tr>";
            }

            eval("\$page = \"".$templates->get('newpoints_rps')."\";");
            output_page($page);
        }
        elseif($mybb->input['action'] == 'send_bet')
        {
            verify_post_check($mybb->input['postcode']);

            $to = get_user_by_username($mybb->input['username']);
            $amount = floatval($mybb->input['amount']);
            $option = intval($mybb->input['option']);
            $minamount = intval($mybb->settings['newpoints_rps_minbet']);

            /*
             * is the receiver of bet a valid user?
             * is the bet a valid amount?
             * can the user afford it?
             * has the user selected a valid option?
             * can the opposing user afford it?
             */
            if(!$to || $to['uid'] == $mybb->user['uid']) error('Invalid user');
            if($minamount > $amount) error('Invalid bet amount');
            if($amount > $mybb->user['newpoints']) error('You cannont afford that bet');
            if($option < 1 || $option > 3) error('Invalid option');

            $query = $db->simple_select('users', 'newpoints', "uid = {$to['uid']}");
            $receiver = $db->fetch_array($query);

            if($amount > $receiver['newpoints']) error('The opposing user cannot afford this bet.');

            // user is only allowed 5 pending to bets at any one time
            $num_of_bets = $db->num_rows($db->simple_select('newpoints_rps_bets', 'betid', "`from` = {$mybb->user['uid']} AND winner = 0"));
            if($num_of_bets == 5) error('You can only have a maximium of <strong>5</strong> pending bets sent from yourself');

            /*
             * minus the amount from user's balance
             * insert bet into the database
             * send receiving user a PM
             * redirect to newpoints home
             */
            newpoints_addpoints($mybb->user['uid'], -$amount);

            $db->insert_query('newpoints_rps_bets', array('from' => $mybb->user['uid'], 'to' => $to['uid'], 'amount' => $amount, 'option' => $option, 'startdate' => time()));
            $betid = $db->insert_id();

            newpoints_send_pm(array(
                'subject' => 'New Bet',
                'message' => "Hi,\n\nI have invited you for a bet of [b]{$amount}[/b].\n\nIf you would like to reject this bet, click [b][url={$mybb->settings['bburl']}/newpoints.php?action=rejectbet&betid={$betid}]here[/url][/b], otherwise click one of the following options:[list][*][url={$mybb->settings['bburl']}/newpoints.php?action=acceptbet&betid={$betid}&option=1]Rock[/url][*][url={$mybb->settings['bburl']}/newpoints.php?action=acceptbet&betid={$betid}&option=2]Paper[/url][*][url={$mybb->settings['bburl']}/newpoints.php?action=acceptbet&betid={$betid}&option=3]Scissors[/url][/list]\n\nGood-luck!",
                'receivepms' => 1,
                'touid' => $to['uid']));

            redirect($mybb->settings['bburl']."/newpoints.php?action=rps", 'Your bet has been successfully sent to the opposing user. Good-luck!', 'Rock-Paper-Scissors Bet Sent');
        }
        elseif($mybb->input['action'] == 'acceptbet')
        {
            $betid = intval($mybb->input['betid']);
            if($betid <= 0) error('Invalid bet');

            $option = intval($mybb->input['option']);
            if($option < 0 || $option > 3) error('Invalid option');

            $query = $db->simple_select('newpoints_rps_bets', '*', "betid = {$betid} AND winner = 0");
            $bet = $db->fetch_array($query);

            if(empty($bet)) error('Invalid bet');
            if($bet['to'] != $mybb->user['uid']) error_no_permission();

            if($bet['amount'] > $mybb->user['newpoints']) error('You don\'t have enough points');

            newpoints_addpoints($bet['to'], -$bet['amount']);

            /*
             * bet statuses:
             * 0 = pending
             * uid = this person won
             * -1 = draw
             */

            // 1 = rock, 2 = paper, 3 = scissors

            if($bet['option'] == 1 && $option == 2)
                $win_user = $mybb->user['uid'];
            elseif($bet['option'] == 2 && $option == 3)
                $win_user = $mybb->user['uid'];
            elseif($bet['option'] == 3 && $option == 1)
                $win_user = $mybb->user['uid'];
            elseif($bet['option'] == $option)
                $win_user = -1;
            else
                $win_user = $bet['from'];

            $winnings = $bet['amount'] * 2;

            $db->update_query('newpoints_rps_bets', array('winner' => $win_user, 'enddate' => time()), "betid = {$betid}");

            if($win_user == $bet['from'])
            {
                newpoints_addpoints($bet['from'], $winnings);
                $winner = $bet['from'];
                $loser = $bet['to'];
            }
            elseif($win_user == $mybb->user['uid'])
            {
                newpoints_addpoints($bet['to'], $winnings);
                $winner = $bet['to'];
                $loser = $bet['from'];
            }
            else
            {
                // draw therefore refund both users
                newpoints_addpoints($bet['from'], $bet['amount']);
                newpoints_addpoints($bet['to'], $bet['amount']);
            }

            // Send PMs
            if(empty($winner))
            {
                newpoints_send_pm(
                    array(
                        'subject' => 'Bet - Draw',
                        'message' => 'Our bet has resulted in a stalemate therefore we have both been refunded.',
                        'receivepms' => 1,
                        'touid' => $bet['to']
                    )
                );

                newpoints_send_pm(
                    array(
                        'subject' => 'Bet - Draw',
                        'message' => 'Our bet has resulted in a stalemate therefore we have both been refunded.',
                        'receivepms' => 1,
                        'touid' => $bet['from']
                    )
                );
            }
            else
            {
                newpoints_send_pm(
                    array(
                        'subject' => 'Bet - Won',
                        'message' => "Congrats!\n\nYou have won the bet of [b]{$bet['amount']}[/b].",
                        'receivepms' => 1,
                        'touid' => $winner
                    )
                );

                newpoints_send_pm(
                    array(
                        'subject' => 'Bet - Lost',
                        'message' => "You have unfortunately lost our bet of {$bet['amount']}.",
                        'receivepms' => 1,
                        'touid' => $loser
                    )
                );
            }

            redirect('newpoints.php?action=rps', 'Bet finished - returning to NewPoints home', 'Bet Finished');
        }
        elseif($mybb->input['action'] == 'rejectbet')
        {
            $betid = intval($mybb->input['betid']);
            if($betid <= 0) error('Invalid bet');

            $query = $db->simple_select('newpoints_rps_bets', '*', "betid = {$betid} AND winner = 0");
            $bet = $db->fetch_array($query);

            if(empty($bet)) error('Invalid bet');

            if($bet['to'] == $mybb->user['uid'] || $bet['from'] == $mybb->user['uid']) {

                if ($mybb->user['uid'] != $bet['from'])
                    newpoints_send_pm(
                        array(
                            'subject' => 'Bet - Rejected',
                            'message' => "I have rejected our bet of {$bet['amount']}.",
                            'receivepms' => 1,
                            'touid' => $bet['from']
                        )
                    );

                newpoints_addpoints($bet['from'], $bet['amount']);

                $db->delete_query('newpoints_rps_bets', "betid = {$betid}");

                redirect('newpoints.php?action=rps', 'You have rejected this bet.', 'Bet Rejected');
            }
            else
            {
                error_no_permission();
            }
        }
    }

    function work_out_status($winner)
    {
        global $mybb;

        if($winner == $mybb->user['uid'])
            $result = 'Won';
        elseif($winner == -1)
            $result = 'Draw';
        else
            $result = 'Loss';

        return $result;
    }