<?php
if(!defined("IN_MYBB"))
{
    die("This file cannot be accessed directly.");
} 

$plugins->add_hook('member_profile_end', 'showrefer');

// The information that shows up on the plugin manager
function showrefer_info()
{
	return array(
		"name"		=> "Referral in Profile",
		"description"	=> "This plugin displays the user's referrals in their profiles.",
		"website"	=> "http://www.leefish.nl",
		"author"	=> "LeeFish based on work by Jeff Chan",
		"authorsite"	=> "http://www.leefish.nl",
		"version"	=> "1.1",
		'compatibility' => "*"
	);
}

// This function is called to establish whether the plugin is installed or not
function showrefer_is_installed()
{
	global $db;
	
	$query = $db->simple_select("templates", "`title`", "`title` = 'member_profile_showrefer'");
	$g = $db->fetch_array($query);
	if($g)
	{
		return true;
	}
	return false;
}

function showrefer_install() {
	global $db;

	$showrefer_template = array(
		"title"		=> 'member_profile_showrefer',
		"template"	=> "<tr>
	<td class=\"trow1\ \"valign = top\"><strong>Referrals ({\$showrefer_count})</strong></td>
	<td class=\"trow1\">{\$showrefer_referrals}</td>
</tr>",
		"sid"		=> -1,
		"version"	=> 120,
		"status"	=> '',
		"dateline"	=> 1134703642,
	);
	//Create Referrals in Profiles template
	$db->insert_query('templates', $showrefer_template);
}

// This function runs when the plugin is activated.
function showrefer_activate()
{
	// Insert code into profile template
	require_once MYBB_ROOT."/inc/adminfunctions_templates.php";
	find_replace_templatesets("member_profile", '#{\$reputation}#', "{\$reputation}\n{\$showrefer}\n");
}

// This function runs when the plugin is deactivated.
function showrefer_deactivate()
{
	// Remove code from template
	require_once MYBB_ROOT."/inc/adminfunctions_templates.php";
	find_replace_templatesets("member_profile", '#(\n?){\$showrefer}(\n?)#', '', 0);
}

// This function runs when the plugin is deactivated.
function showrefer_uninstall()
{
    global $db;

	// Remove code from template
	require_once MYBB_ROOT."/inc/adminfunctions_templates.php";
	find_replace_templatesets("member_profile", '#(\n?){\$showrefer}(\n?)#', '', 0);
	
	//Delete Referrals in Profiles template
	$db->delete_query("templates", "`title` = 'member_profile_showrefer'");
	
	//Rebuild settings.php
	rebuild_settings();
}

function showrefer()
{
	global $mybb, $templates, $db, $theme, $showrefer_count, $showrefer, $showrefer_referrals;
	
	$query = $db->query("
				SELECT u.*, u.username, u.uid, u.referrer, u.referrals
				FROM ".TABLE_PREFIX."users u
				WHERE u.referrer > '0'
				AND u.referrer = '".intval($GLOBALS['uid'])."'
				");			
				
	$showrefer_count = $db->num_rows($query);
	
	if($showrefer_count > 0)
	{
		$sep = "";
		while($referral = $db->fetch_array($query))
		{
			$showrefer_referrals .= $sep.build_profile_link($referral['username'], $referral['uid']);
			$sep = ", ";
        	}
	}
	else
	{
		$showrefer_referrals = "None";
	}
	eval("\$showrefer = \"".$templates->get('member_profile_showrefer')."\";");
}
?>