<?php
/***************************************************************************
 *
 *   Betting plugin (/inc/tasks/betting.php)
 *	 Author: ZLight Software
 *   Copyright:  2013 ZLight Software
 *   
 *   Website: http://zlightsoftware.com
 *   License: licence.txt
 *
 *   Integrates a Betting system with NewPoints.
 *
 ***************************************************************************/
 
/****************************************************************************
* LICENCE: The licence file is named licence.txt and comes with this product.
* In case licence.txt does not come with this product, please contact 
* ZLight Software immediatly.
****************************************************************************/

function task_betting($task)
{
	global $mybb, $db, $lang, $cache, $templates;
	
	newpoints_lang_load("betting");
	
	$lottery = $cache->read("betting_lottery");
	$round = (int)$lottery['round'];
	$time = $lottery['time'];
	
	if(TIME_NOW > $time+$mybb->settings['betting_lottery_time'])
	{
		// Let's find ourselves a winner
		$query = $db->simple_select('betting_lottery', '*', 'round='.$round, array('order_by' => 'rand()', 'limit' => 1));
		$winner = $db->fetch_array($query);
		if(empty($winner))
		{
			// No winner
		}
		else
		{
			$db->update_query('betting_lottery', array('winner' => 1), 'tid='.(int)$winner['tid']);
			
			// Sum all points spent on this draw/round
			$query = $db->simple_select('betting_lottery', 'SUM(points) as points', 'round='.$round);
			$points = $db->fetch_field($query, 'points');
			
			// Give points to the winner
			newpoints_addpoints($winner['uid'], $points+$mybb->settings['betting_lottery_pot']);
		}
		
		$cache->update('betting_lottery', array('round' => $round+1, 'time' => TIME_NOW));
	}

	add_task_log($task, $lang->betting_task_ran);
}

?>
