<?php
//disallow direct access to file
if(!defined("IN_MYBB")){
	die("Direct initialization of this file is not allowed.<br /><br />Please make sure IN_MYBB is defined.");
}
//load the language file
$lang->load("shops_categories");

//add the tabs...
$sub_tabs['manage'] = array(
	'title' => $lang->manage_categories,
	'link' => "index.php?module=shops-categories",
	'description' => $lang->manage_categories_description
);
$sub_tabs['new'] = array(
	'title' => $lang->new_category,
	'link' => "index.php?module=shops-categories&action=edit",
	'description' => $lang->new_category_description
);

//add breadcrumb
$page->add_breadcrumb_item($lang->manage_categories, "index.php?module=shops-categories");

//edit category
if($mybb->input['action'] == "edit"){
	if($mybb->input['id']){ //edit
		//select category
		$query = $db->simple_select("shops_categories","*","id=".intval($mybb->input['id']));
		//check if exists..
		if($db->num_rows($query) != 1){
			//get outta here!
			flash_message($lang->error_no_category,'error');
			admin_redirect('index.php?module=shops-categories');
		}
		//Alright, it exists. Let's assign it's variable.
		$c = $db->fetch_array($query);
		//ID to add to the end of the Form action. (to make sure it edits the correct category ;)
		$id = "&id={$mybb->input['id']}";
		//Title of the form
		$title = $lang->edit_category;
		//add another tab for editing.
		$sub_tabs['edit'] = array(
			'title' => $lang->edit_category,
			'link' => "index.php?module=shops-categories&action=edit&id={$mybb->input['id']}",
			'description' => $lang->edit_category_description
		);
	}else{
		//guess we're making a new one... assign some dummy variables :D
		$id = "";
		$title = $lang->new_category;
		$c['title'] = $mybb->input['title'];
		$c['description'] = $mybb->input['description'];
	}
	
	//process the form.
	if($mybb->request_method == "post"){
		//check if there is a title.
		if(empty($mybb->input['title'])){
			$errors[] = $lang->error_no_title;
		}
		//upload an image.. if there is one.
		if($_FILES['image']['error'] != 4){
			//create an array of allowed filetypes.
			$allowedfiletypes = explode(",",$mybb->settings['shops_allowedimages']);
			//assign a variable to $_FILES['image'] to make it a bit nicer
			$file = $_FILES['image'];
			//check if it is a valid filetype
			if(!in_array($file['type'],$allowedfiletypes)){
				$displaytypes = implode(", ",$allowedfiletypes);
				$errors[] = sprintf($lang->error_invalid_file, $displaytypes);
			}
			//Aw man. a php error uploading the image..
			if($file['error'] != 0){
				$errors = sprintf($lang->error_upload_file_x, $file['error']);
			}
			
			//Oh yeah.. no errors were found.
			if(!$errors){
				//Delete old image (if it exists)
				if($mybb->input['id']){
					if(@file_exists(MYBB_ROOT.$mybb->settings['shops_imagelocation']."/".$c['image'])){
						@unlink(MYBB_ROOT.$mybb->settings['shops_imagelocation']."/".$c['image']);
					}
				}
				//grab the extension - man i love pathinfo() :D
				$ext = pathinfo($file['name'], PATHINFO_EXTENSION);
				//generate filename.
				$filename = "cat_".TIME_NOW."_".md5(random_str()).".".$ext;
				//require the upload functions that come with MyBB (why would i make my own? :D)
				require_once(MYBB_ROOT."inc/functions_upload.php");
				//attempt to upload the file.
				$upload = upload_file($file, MYBB_ROOT.$mybb->settings['shops_imagelocation'], $filename);
				//weird.. couldn't do it.
				if(!$upload){
					$errors[] = $lang->error_upload_file;
				}
			}
		}else{
			//is it a new post? Are we removing the image?
			if(!$mybb->input['id'] || $mybb->input['removeimg'] == 1){
				//YES RESET NOW.
				if(@file_exists(MYBB_ROOT.$mybb->settings['shops_imagelocation']."/".$c['image'])){
					@unlink(MYBB_ROOT.$mybb->settings['shops_imagelocation']."/".$c['image']);
				}
				$filename = "";
			}else{
				//nah... just keep the old one.
				$filename = $c['image'];
			}
		}
		//W00T. No errors... let's insert it!
		if(!$errors){
			//fields to insert..
			$field['title'] = $mybb->input['title'];
			$field['description'] = $mybb->input['description'];
			$field['image'] = $filename;
			if($mybb->input['id']){
				//update existing category.
				$query = $db->update_query("shops_categories",$field,"id=".intval($mybb->input['id']));
				if($query){
					flash_message($lang->success_edited_category,'success');
					admin_redirect("index.php?module=shops-categories");
				}
			}else{
				//create a new category
				$query = $db->insert_query("shops_categories",$field);
				if($query){
					flash_message($lang->success_new_category,'success');
					admin_redirect("index.php?module=shops-categories");
				}
			}
		}
	}
	$page->output_header($lang->edit_category);
	//output the tabs.
	$page->output_nav_tabs($sub_tabs, ($mybb->input['id'])?"edit":"new");
	if($errors){
		// Uh Oh. We have some errors.. guess we'll need to show them.
		$page->output_inline_error($errors);
	}

	//start the form. (and add the $id variable if needed.
	$form = new Form("index.php?module=shops-categories&action=edit{$id}", "post", "", 1);
	//and a form container.. to contain the form.
	$form_container = new FormContainer($title);

	//Title Box
	$form_container->output_row($lang->title."<em>*</em>",$lang->title_desc,$form->generate_text_box('title',$c['title'],array('id' => 'title')), 'title');
	//Description Box
	$form_container->output_row($lang->description,$lang->description_desc,$form->generate_text_area('description',$c['description'],array('id' => 'description')), 'description');
	if($mybb->input['id']){
		//If we're editing a category -- Delete Image Box
		$form_container->output_row($lang->remove_image,$lang->remove_image_desc,$form->generate_yes_no_radio('removeimg',0,array('id' => 'removeimg')),'removeimg');
	}
	//Image Box.
	$form_container->output_row($lang->image,$lang->image_desc,$form->generate_file_upload_box('image',array('id' => 'image')), 'image');

	//End the form container.
	$form_container->end();

	//create the submit button. *oh how i love the Form Class, makes everything so easy.*
	$buttons[] = $form->generate_submit_button($lang->save_category);
	//and output aforementioned button ;)
	$form->output_submit_wrapper($buttons);

	//end the form.
	$form->end();
	$page->output_footer();
}

//Let's delete a category.
if($mybb->input['action'] == "delete"){
	//select category
	$query = $db->simple_select("shops_categories","*","id=".intval($mybb->input['id']));
	//check if the category even exists.
	if($db->num_rows($query) == 1){
		//it does! - assign a variable
		$c = $db->fetch_array($query);

		//delete it's image (if one exists).
		if(@file_exists(MYBB_ROOT.$mybb->settings['shops_imagelocation'].$c['image'])){
			@unlink(MYBB_ROOT.$mybb->settings['shops_imagelocation'].$c['image']);
		}
		//NUKE IT.
		$db->delete_query("shops_categories","id=".intval($mybb->input['id']));
		flash_message($lang->success_category_deleted,'success');
		admin_redirect('index.php?module=shops-categories');
	}else{
		//hmm. Why are you coming here to delete a nonexisting category.. say bye!
		flash_message($lang->error_no_category,'error');
		admin_redirect('index.php?module=shops-categories');
	}
}
//Just the main page.
if(!$mybb->input['action']){
	$page->output_header($lang->manage_categories);

	//output the tabs.
	$page->output_nav_tabs($sub_tabs, 'manage');

	//create a table to make things pretty :P
	$table = new Table;

	//create the headers..
	$table->construct_header($lang->image,array('class' => 'align_center','width' => '110px'));
	$table->construct_header($lang->title);
	$table->construct_header($lang->controls,array('class' => 'align_center','width' => '200px'));

	//get the categories
	$query = $db->simple_select("shops_categories","*");

	//loop it up.
	while($c = $db->fetch_array($query)){
		//create a popup box
		$popup = new PopupMenu("cat_{$c['id']}", $lang->options);
		$popup->add_item($lang->edit_category,"index.php?module=shops-categories&action=edit&id={$c['id']}");
		$popup->add_item($lang->delete_category,"index.php?module=shops-categories&action=delete&id={$c['id']}", "return AdminCP.deleteConfirmation(this, '{$lang->confirm_category_deletion}')");

		//create all the needed cells/rows.
		$table->construct_cell("<img src=\"{$mybb->settings['bburl']}/{$mybb->settings['shops_imagelocation']}{$c['image']}\" width=\"100px\">");
		$table->construct_cell("<a href=\"index.php?module=shops-categories&action=edit&id={$c['id']}\"><strong>{$c['title']}</strong></a>");
		$table->construct_cell($popup->fetch(),array('class' => 'align_center'));
		$table->construct_row();
	}

	//output this beautiful table.
	$table->output($lang->manage_categories);
	$page->output_footer();
}
?>