<?php
//disallow direct access to file
if(!defined("IN_MYBB")){
	die("Direct initialization of this file is not allowed.<br /><br />Please make sure IN_MYBB is defined.");
}

//load the language
$lang->load("shops_products");

//create some tabs
$sub_tabs['manage'] = array(
	'title' => $lang->manage_products,
	'link' => "index.php?module=shops-products",
	'description' => $lang->manage_products_description
);
$sub_tabs['new'] = array(
	'title' => $lang->new_product,
	'link' => "index.php?module=shops-products&action=edit",
	'description' => $lang->new_product_description
);

//add breadcrumb for easy navigation
$page->add_breadcrumb_item($lang->manage_products, "index.php?module=shops-products");

//manage files
if($mybb->input['action'] == "files"){
	//grab the products
	$query = $db->simple_select("shops_products","*","id=".intval($mybb->input['pid']));
	if($db->num_rows($query) != 1){
		flash_message($lang->error_no_product,'error');
		admin_redirect('index.php?module=shops-products');
	}
	$p = $db->fetch_array($query);
	//add tab for manage files
	$sub_tabs['files'] = array(
		'title' => $lang->manage_files,
		'link' => "index.php?module=shops-products&action=files&pid={$mybb->input['pid']}",
		'description' => $lang->manage_files_description
	);
	$sub_tabs['newfile'] = array(
		'title' => $lang->new_file,
		'link' => "index.php?module=shops-products&action=files&pid={$mybb->input['pid']}&act=edit",
		'description' => $lang->new_file_description
	);

	if($mybb->input['act'] == "delete"){
		$query = $db->simple_select("shops_files","*","id=".intval($mybb->input['id']));
		//check if it exists
		if($db->num_rows($query) == 1){
			//assign it a variable
			$c = $db->fetch_array($query);
			//remove image (if one exists)
			if(file_exists(MYBB_ROOT.$mybb->settings['shops_filelocation'].$c['location'])){
				@unlink(MYBB_ROOT.$mybb->settings['shops_filelocation'].$c['location']);
			}
			//delete the row, and redirect.
			$db->delete_query("shops_files","id=".intval($mybb->input['id']));
			flash_message($lang->success_file_deleted,'success');
			admin_redirect("index.php?module=shops-products&action=files&pid={$mybb->input['pid']}");
		}else{
			//get out :D
			flash_message($lang->error_no_file,'error');
			admin_redirect("index.php?module=shops-products&action=files&pid={$mybb->input['pid']}");
		}
	}
	if($mybb->input['act'] == "edit"){
		//check if we're making a new one, or editing an existing one.
		if($mybb->input['id']){
			//select the file
			$query = $db->simple_select("shops_files","*","id=".intval($mybb->input['id']));
			//check if it exists
			if($db->num_rows($query) != 1){
				flash_message($lang->error_no_file,'error');
				admin_redirect("index.php?module=shops-products&action=files&pid={$mybb->input['pid']}");
			}
			//assign it's variable
			$f = $db->fetch_array($query);
			//ID for the form action
			$id = "&id={$mybb->input['id']}";
			//form title
			$title = $lang->edit_file;
			//add a tab for editing.
			$sub_tabs['editfile'] = array(
				'title' => $lang->edit_file,
				'link' => "index.php?module=shops-products&action=files&pid={$mybb->input['pid']}&act=edit&id={$mybb->input['id']}",
				'description' => $lang->edit_file_description
			);
		}else{
			//making a new file -- dummy variables
			$id = "";
			$title = $lang->new_file;
			$f['title'] = $mybb->input['title'];
		}
		//process the file
		if($mybb->request_method == "post"){
			//Check if it has a title.
			if(empty($mybb->input['title'])){
				$errors[] = $lang->error_no_title;
			}
			//check if we're uploading a file
			if($_FILES['upload']['error'] != 4){
				//create an array of allowed file types
				$allowedfiletypes = explode(",",$mybb->settings['shops_allowedfiles']);
				//assign a nicer variable to $_FILES['upload']
				$file = $_FILES['upload'];
				//check if it's a valid filetype
				if(!in_array($file['type'],$allowedfiletypes)){
					$displaytypes = implode(", ",$allowedfiletypes);
					$errors[] = sprintf($lang->error_invalid_file, $displaytypes);
				}
				//PHP error -- throw it out there.
				if($file['error'] != 0){
					$errors = sprintf($lang->error_upload_file_x, $file['error']);
				}
				//No errors. let's continue.
				if(!$errors){
					//Delete old file (if there was one)
					if($mybb->input['id']){
						if(@file_exists(MYBB_ROOT.$mybb->settings['shops_filelocation']."/".$f['location'])){
							@unlink(MYBB_ROOT.$mybb->settings['shops_filelocation']."/".$f['location']);
						}
					}
					//grab the file extension
					$ext = pathinfo($file['name'], PATHINFO_EXTENSION);
					//create the filename
					$filename = "file_".TIME_NOW."_".md5(random_str()).".".$ext;
					//grab MyBB's nifty file upload functions.
					require_once(MYBB_ROOT."inc/functions_upload.php");
					//upload the file
					$upload = upload_file($file, MYBB_ROOT.$mybb->settings['shops_filelocation'], $filename);
					//Didn't upload.
					if(!$upload){
						$errors[] = $lang->error_upload_file;
					}
				}
			}else{
				//no file needed... check if we're deleting one though.
				if(!$mybb->input['id']){
					//remove old one
					if(@file_exists(MYBB_ROOT.$mybb->settings['shops_filelocation']."/".$f['location'])){
						@unlink(MYBB_ROOT.$mybb->settings['shops_filelocation']."/".$f['location']);
					}
					$filename = "";
				}else{
					//nope. we're keeping the original.
					$filename = $f['location'];
					$file['name'] = $f['origname'];
					$file['type'] = $f['mimetype'];
				}
			}
			//no errors.. start inserting
			if(!$errors){
				//Fields to insert
				$field['pid'] = intval($mybb->input['pid']);
				$field['title'] = $mybb->input['title'];
				$field['location'] = $filename;
				$field['origname'] = $file['name'];
				$field['mimetype'] = $file['type'];
				if($mybb->input['fid']){
					$field['dateline'] = $f['dateline'];
				}else{
					$field['dateline'] = TIME_NOW;
				}
				//format the 'length' field to a valid UNIX timestamp.
				if($mybb->input['id']){
					//update existing file
					$query = $db->update_query("shops_files",$field,"id=".intval($mybb->input['id']));
					if($query){
						flash_message($lang->success_edited_file,'success');
						admin_redirect("index.php?module=shops-products&action=files&pid={$mybb->input['pid']}");
					}
				}else{
					//create a brand new one.
					$query = $db->insert_query("shops_files",$field);
					if($query){
						flash_message($lang->success_new_file,'success');
						admin_redirect("index.php?module=shops-products&action=files&pid={$mybb->input['pid']}");
					}
				}
			}
		}
		$page->output_header($lang->edit_file);
		//output the tabs.
		$page->output_nav_tabs($sub_tabs, ($mybb->input['id'])?"editfile":"newfile");
		if($errors){
			//output some errors (if there were any)
			$page->output_inline_error($errors);
		}
		//create the form and form container
		$form = new Form("index.php?module=shops-products&action=files&pid={$mybb->input['pid']}&act=edit{$id}", "post", "", 1);
		$form_container = new FormContainer($title);

		//Title
		$form_container->output_row($lang->title."<em>*</em>",$lang->title_desc,$form->generate_text_box('title',$f['title'],array('id' => 'title')), 'title');
		//file
		$form_container->output_row($lang->file,$lang->file_desc,$form->generate_file_upload_box('upload',array('id' => 'upload')), 'upload');

		//end form container.
		$form_container->end();

		//create submit button
		$buttons[] = $form->generate_submit_button($lang->save_file);
		$form->output_submit_wrapper($buttons);

		$form->end();
		$page->output_footer();
	}
	if(!$mybb->input['act']){
		$page->output_header($lang->manage_files);
		$page->output_nav_tabs($sub_tabs, 'files');

		//create table
		$table = new Table;

		//create headers
		$table->construct_header($lang->title);
		$table->construct_header($lang->controls,array('class' => 'align_center','width' => '200px'));

		//grab the files
		$query = $db->simple_select("shops_files","*","pid=".intval($mybb->input['pid']));
		
		//loop them.
		while($f = $db->fetch_array($query)){
			//create popup menu
			$popup = new PopupMenu("file_{$f['id']}", $lang->options);
			$popup->add_item($lang->edit_file,"index.php?module=shops-products&action=files&pid={$mybb->input['pid']}&act=edit&id={$f['id']}");
			$popup->add_item($lang->delete_file,"index.php?module=shops-products&action=files&pid={$mybb->input['pid']}&act=delete&id={$f['id']}", "return AdminCP.deleteConfirmation(this, '{$lang->confirm_product_deletion}')");

			//create cells and row.
			$table->construct_cell("<strong>{$f['title']}</strong> (".$f['mimetype'].")");
			$table->construct_cell($popup->fetch(),array('class' => 'align_center'));
			$table->construct_row();
		}

		//output table
		$table->output($lang->manage_files);
		$page->output_footer();
	}
}

//give a product to a user manually
if($mybb->input['action'] == "give"){
	//check if product even exists
	$query = $db->simple_select("shops_products","*","id=".intval($mybb->input['id']));
	if($db->num_rows($query) != 1){
		flash_message($lang->error_no_product,'error');
		admin_redirect('index.php?module=shops-products');
	}
	$p = $db->fetch_array($query);
	//form submitted... award user his product
	if($mybb->request_method == "post"){
		//check if user exists
		$query = $db->simple_select("users","*","username='".$mybb->input['username']."'");
		if($db->num_rows($query) != 1){
			flash_message($lang->error_no_user,'error');
			admin_redirect("index.php?module=shops-products&action=give&id={$p['id']}");
		}
		//assign a variable to the user
		$u = $db->fetch_array($query);

		//insert the purchase
		$insert['uid'] = $u['uid'];
		$insert['pid'] = $p['id'];
		if($p['length'] != -1){
			$insert['expireson'] = TIME_NOW + $p['length'];
		}else{
			$insert['expireson'] = -1;
		}
		$db->insert_query("shops_purchases",$insert);
		
		$update['usergroup'] = $p['usergroup'];
		$db->update_query("users",$update,"uid={$u['uid']}");

		flash_message($lang->success_give_user,'success');
		admin_redirect('index.php?module=shops-products');
	}
	$page->output_header($lang->give_user);
	//create the form and form container
	$form = new Form("index.php?module=shops-products&action=give&id={$p['id']}", "post");
	$form_container = new FormContainer($lang->give_user);

	//Username
	$form_container->output_row($lang->username."<em>*</em>",$lang->username_desc,$form->generate_text_box('username',$mybb->input['username'],array('id' => 'username')), 'username');

	//end form container.
	$form_container->end();

	//create submit button
	$buttons[] = $form->generate_submit_button($lang->give_user);
	$form->output_submit_wrapper($buttons);

	$form->end();
	$page->output_footer();
}
//edit the product.
if($mybb->input['action'] == "edit"){
	//check if we're making a new one, or editing an existing one.
	if($mybb->input['id']){
		//select the product
		$query = $db->simple_select("shops_products","*","id=".intval($mybb->input['id']));
		//check if it exists
		if($db->num_rows($query) != 1){
			flash_message($lang->error_no_product,'error');
			admin_redirect('index.php?module=shops-products');
		}
		//assign it's variable
		$p = $db->fetch_array($query);
		//ID for the form action
		$id = "&id={$mybb->input['id']}";
		//form title
		$title = $lang->edit_product;
		//add a tab for editing.
		$sub_tabs['edit'] = array(
			'title' => $lang->edit_product,
			'link' => "index.php?module=shops-products&action=edit&id={$mybb->input['id']}",
			'description' => $lang->edit_product_description
		);
	}else{
		//making a new product -- dummy variables
		$id = "";
		$title = $lang->new_product;
		$p['title'] = $mybb->input['title'];
		$p['description'] = $mybb->input['description'];
		$p['tos'] = $mybb->input['tos'];
		$p['price'] = $mybb->input['price'];
		$p['renew_price'] = $mybb->input['renew_price'];
		$p['length'] = $mybb->input['length'];
		$p['owned'] = $mybb->input['owned'];
		if($mybb->input['usergroup']){
			$p['usergroup'] = $mybb->input['usergroup'];
		}else{
			$p['usergroup'] = 2;
		}
	}
	//process the product
	if($mybb->request_method == "post"){
		//Check if it has a title.
		if(empty($mybb->input['title'])){
			$errors[] = $lang->error_no_title;
		}
		//check if we're uploading an image
		if($_FILES['image']['error'] != 4){
			//create an array of allowed file types
			$allowedfiletypes = explode(",",$mybb->settings['shops_allowedimages']);
			//assign a nicer variable to $_FILES['image']
			$file = $_FILES['image'];
			//check if it's a valid filetype
			if(!in_array($file['type'],$allowedfiletypes)){
				$displaytypes = implode(", ",$allowedfiletypes);
				$errors[] = sprintf($lang->error_invalid_file, $displaytypes);
			}
			//PHP error -- throw it out there.
			if($file['error'] != 0){
				$errors = sprintf($lang->error_upload_file_x, $file['error']);
			}
			//No errors. let's continue.
			if(!$errors){
				//Delete old image (if there was one)
				if($mybb->input['id']){
					if(@file_exists(MYBB_ROOT.$mybb->settings['shops_imagelocation']."/".$p['image'])){
						@unlink(MYBB_ROOT.$mybb->settings['shops_imagelocation']."/".$p['image']);
					}
				}
				//grab the file extension
				$ext = pathinfo($file['name'], PATHINFO_EXTENSION);
				//create the filename
				$filename = "prod_".TIME_NOW."_".md5(random_str()).".".$ext;
				//grab MyBB's nifty file upload functions.
				require_once(MYBB_ROOT."inc/functions_upload.php");
				//upload the file
				$upload = upload_file($file, MYBB_ROOT.$mybb->settings['shops_imagelocation'], $filename);
				//Didn't upload.
				if(!$upload){
					$errors[] = $lang->error_upload_file;
				}
			}
		}else{
			//no image needed... check if we're deleting one though.
			if(!$mybb->input['id'] || $mybb->input['removeimg'] == 1){
				//remove old one
				if(@file_exists(MYBB_ROOT.$mybb->settings['shops_imagelocation']."/".$p['image'])){
					@unlink(MYBB_ROOT.$mybb->settings['shops_imagelocation']."/".$p['image']);
				}
				$filename = "";
			}else{
				//nope. we're keeping the original.
				$filename = $p['image'];
			}
		}
		//no errors.. start inserting
		if(!$errors){
			//Fields to insert
			$field['title'] = $mybb->input['title'];
			$field['category'] = $mybb->input['category'];
			$field['usergroup'] = $mybb->input['usergroup'];
			$field['description'] = $mybb->input['description'];
			$field['tos'] = addslashes($mybb->input['tos']);
			$field['image'] = $filename;
			//format the 'length' field to a valid UNIX timestamp.
			if($mybb->input['length2'] != -1)
				$field['length'] = intval($mybb->input['length1']) * intval($mybb->input['length2']);
			else
				$field['length'] = -1;
			$field['owned'] = $mybb->input['owned'];
			$field['price'] = $mybb->input['price'];
			$field['renew_price'] = $mybb->input['renew_price'];
			if($mybb->input['id']){
				//update existing product
				$query = $db->update_query("shops_products",$field,"id=".intval($mybb->input['id']));
				if($query){
					flash_message($lang->success_edited_product,'success');
					admin_redirect("index.php?module=shops-products");
				}
			}else{
				//create a brand new one.
				$query = $db->insert_query("shops_products",$field);
				if($query){
					flash_message($lang->success_new_product,'success');
					admin_redirect("index.php?module=shops-products");
				}
			}
		}
	}

	//convert unix timestamp to something a bit more friendly.
	if($p['length'] == -1){
		$length2 = -1; //forever
	}elseif($p['length'] >= 31104000){
		$length2 = 31104000; //years
	}elseif($p['length'] >= 2592000){
		$length2 = 2592000; //months
	}elseif($p['length'] >= 604800){
		$length2 = 604800; //weeks
	}else{
		$length2 = 864800; //days
	}
	if($length2 != -1){
		$length1 = $p['length'] / $length2; //Find the # of years/months/weeks/days
	}

	/**
	* The different time periods availible. Please do not do something like 8 days, or 13 months because
	* it will break and you will get a decimal when you edit it. It will work fine, but will be kinda
	* ugly.
	**/
	$lengthoptions = array(
		864800		=> $lang->days,
		604800		=> $lang->weeks,
		2592000		=> $lang->months,
		31104000	=> $lang->years,
		-1			=> $lang->forever,
	);

	//get the categories
	$categories = $db->simple_select("shops_categories","*");
	if($db->num_rows($categories) == 0){
		flash_message($lang->error_no_category,'error');
		admin_redirect('index.php?module=shops-categories');
	}

	//create an array of them.
	while($c = $db->fetch_array($categories)){
		$catlist[$c['id']] = $c['title'];
	}
	$page->output_header($title);
	//output the tabs.
	$page->output_nav_tabs($sub_tabs, ($mybb->input['id'])?"edit":"new");
	if($errors){
		//output some errors (if there were any)
		$page->output_inline_error($errors);
	}

	//create the form and form container
	$form = new Form("index.php?module=shops-products&action=edit{$id}", "post", "", 1);
	$form_container = new FormContainer($title);

	//Title
	$form_container->output_row($lang->title."<em>*</em>",$lang->title_desc,$form->generate_text_box('title',$p['title'],array('id' => 'title')), 'title');
	//category
	$form_container->output_row($lang->category,$lang->category_desc,$form->generate_select_box('category',$catlist,array($p['category']),array('id' => 'category')),'category');
	//usergroup
	$form_container->output_row($lang->usergroup,$lang->usergroup_desc,$form->generate_group_select('usergroup', array($p['usergroup']), array('id' => 'usergroup')),'usergroup');
	//description
	$form_container->output_row($lang->description,$lang->description_desc,$form->generate_text_area('description',$p['description'],array('id' => 'description')), 'description');
	if($mybb->input['id']){
		//remove image
		$form_container->output_row($lang->remove_image,$lang->remove_image_desc,$form->generate_yes_no_radio('removeimg',0,array('id' => 'removeimg')),'removeimg');
	}
	//image
	$form_container->output_row($lang->image,$lang->image_desc,$form->generate_file_upload_box('image',array('id' => 'image')), 'image');
	//length
	$form_container->output_row($lang->length,$lang->length_desc,$form->generate_text_box('length1',$length1,array('id' => 'length1')).$form->generate_select_box('length2',$lengthoptions,array($length2),array('id' => 'length2')),'length');
	//owned
	$form_container->output_row($lang->owned,$lang->owned_desc,$form->generate_yes_no_radio('owned',$p['owned'],array('id' => 'owned')),'owned');
	//price
	$form_container->output_row($lang->price."<em>*</em>",$lang->price_desc,$form->generate_text_box('price',$p['price'],array('id' => 'price')), 'price');
	//renewal price
	$form_container->output_row($lang->renewal_price."<em>*</em>",$lang->renewal_price_desc,$form->generate_text_box('renew_price',$p['renew_price'],array('id' => 'renew_price')), 'renew_price');
	//terms of service
	$form_container->output_row($lang->tos,$lang->tos_desc,$form->generate_text_area('tos',$p['tos'],array('id' => 'tos')), 'tos');

	//end form container.
	$form_container->end();

	//create submit button
	$buttons[] = $form->generate_submit_button($lang->save_product);
	$form->output_submit_wrapper($buttons);

	$form->end();
	$page->output_footer();
}
//delete product
if($mybb->input['action'] == "delete"){
	$query = $db->simple_select("shops_products","*","id=".intval($mybb->input['id']));
	//check if it exists
	if($db->num_rows($query) == 1){
		//assign it a variable
		$p = $db->fetch_array($query);
		//remove image (if one exists)
		if(file_exists(MYBB_ROOT.$mybb->settings['shops_imagelocation'].$p['image'])){
			@unlink(MYBB_ROOT.$mybb->settings['shops_imagelocation'].$p['image']);
		}
		//remove files
		$getFiles = $db->simple_select("shops_files","*","pid=".$p['id']);
		while($f = $db->fetch_array($getFiles)){
			if(file_exists(MYBB_ROOT.$mybb->settings['shops_filelocation'].$f['location'])){
				@unlink(MYBB_ROOT.$mybb->settings['shops_filelocation'].$f['location']);
			}
		}
		//delete the row, and redirect.
		$db->delete_query("shops_files","pid=".intval($mybb->input['id']));
		$db->delete_query("shops_products","id=".intval($mybb->input['id']));
		flash_message($lang->success_product_deleted,'success');
		admin_redirect('index.php?module=shops-products');
	}else{
		//get out :D
		flash_message($lang->error_no_product,'error');
		admin_redirect('index.php?module=shops-products');
	}
}

//main page
if(!$mybb->input['action']){
	$page->output_header($lang->manage_products);
	$page->output_nav_tabs($sub_tabs, 'manage');

	//create table
	$table = new Table;

	//create headers
	$table->construct_header($lang->image,array('class' => 'align_center','width' => '110px'));
	$table->construct_header($lang->title);
	$table->construct_header($lang->controls,array('class' => 'align_center','width' => '200px'));

	//grab the products
	$query = $db->simple_select("shops_products","*");

	//loop them.
	while($p = $db->fetch_array($query)){
		//create popup menu
		$popup = new PopupMenu("prod_{$p['id']}", $lang->options);
		$popup->add_item($lang->edit_product,"index.php?module=shops-products&action=edit&id={$p['id']}");
		$popup->add_item($lang->give_user,"index.php?module=shops-products&action=give&id={$p['id']}");
		$popup->add_item($lang->manage_files,"index.php?module=shops-products&action=files&pid={$p['id']}");
		$popup->add_item($lang->delete_product,"index.php?module=shops-products&action=delete&id={$p['id']}", "return AdminCP.deleteConfirmation(this, '{$lang->confirm_product_deletion}')");

		//create cells and row.
		$table->construct_cell("<img src=\"{$mybb->settings['bburl']}/{$mybb->settings['shops_imagelocation']}{$p['image']}\" width=\"100px\">");
		$table->construct_cell("<a href=\"index.php?module=shops-products&action=edit&id={$p['id']}\"><strong>{$p['title']}</strong></a>");
		$table->construct_cell($popup->fetch(),array('class' => 'align_center'));
		$table->construct_row();
	}

	//output table
	$table->output($lang->manage_products);
	$page->output_footer();
}
?>